package data;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.Arrays;
import java.util.Scanner;


public class Verifier {

	static File status = new File("status.txt");
	static Scanner statusInput;
	static File sharedFiles = new File("sharedFiles.txt");
	static BufferedWriter temp,threadOut;
	static String fileName = "";
	static long fileLastModified = 0;
	public static void main(String[] args) throws IOException{
		try {
			temp = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(new File("temp.txt"))));
			threadOut = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(new File("threadOut.txt"))));
			if(!status.exists()){
				status.createNewFile();
			}
			statusInput = new Scanner(status);
			Scanner sharedFilesInput;
			sharedFilesInput = new Scanner(sharedFiles);
			while(sharedFilesInput.hasNext()){
				File fileTemp = new File(sharedFilesInput.nextLine());
				if(fileTemp.exists()){
					//printTemp(fileTemp);
					File[] fileTempArray = {fileTemp};
					list(fileTempArray);
				}
				else{
					//Avisar que o arquivo compartilhado nao existe mais.
				}
			}
			while(statusInput.hasNext()){
				fileName = statusInput.nextLine();
				fileLastModified = statusInput.nextLong();
				statusInput.nextLine();
				printErro(fileName,"Delete");
			}
		} catch (FileNotFoundException e) {
			// O arquivo de pastas compartilhadas no existe
			e.printStackTrace();
		}
		statusInput.close();
		if(status.delete()){
			temp.close();
			threadOut.close();
			(new File("temp.txt")).renameTo(status);
		}
		
	}
	public static boolean list(File[] files) throws IOException{
		Arrays.sort(files);
		boolean statusOk = true;
		boolean actualOk = false;
		for (int i = 0; i < files.length; i++) {
			while(!actualOk){
				System.out.println(files[i].getPath());
				if(statusOk){
					if(statusInput.hasNext()){
						fileName = statusInput.nextLine();
						fileLastModified = statusInput.nextLong();
						statusInput.nextLine();
					}
					else{
						listAndSend(files,i);	
						return true;
					}
				}
				System.out.println(files[i].getPath()+" "+fileName);
				if(files[i].getPath().equals(fileName)){
						if(files[i].lastModified() != fileLastModified && files[i].isFile()){
							printErro(files[i],"Envie");
						}
						printTemp(files[i]);
						statusOk = true;
						actualOk = true;
				}
				else if(files[i].getPath().compareTo(fileName) > 0){
					printErro(fileName,"Delete");
					statusOk = true;
					actualOk = false;
				}
				else{
					printTemp(files[i]);
					printErro(files[i],"Envie");
					statusOk = false;
					actualOk = true;
				}
				
			}
			actualOk = false;
			if(files[i].isDirectory()){
				list(files[i].listFiles());
			}
		}
		return true;
	}
	public static void listAndSend(File[] files,int i) throws IOException{
		Arrays.sort(files);
		for (; i < files.length; i++) {
			printTemp(files[i]);
			printErro(files[i],"Envie");
			if(files[i].isDirectory()){
				listAndSend(files[i].listFiles(),0);
			}
		}
	}
	public static void printTemp(File file) throws IOException{
		//System.out.println(file.getPath());
		temp.write(file.getPath()+"\r\n"+file.lastModified()+"\r\n");
	}
	public static void printErro(String file,String type) throws IOException{
		//System.out.println(file.getPath());
		threadOut.write(type+": "+file+"\r\n");
	}
	public static void printErro(File file,String type) throws IOException{
		//System.out.println(file.getPath());
		threadOut.write(type+": "+file.getPath()+"\r\n");
	}
	
}
