package gui;

import java.awt.Component;

import javax.swing.Icon;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;

public class MyCellRenderer extends DefaultTableCellRenderer {   
    @Override  
    public Component getTableCellRendererComponent(JTable table, Object value,   
            boolean isSelected, boolean hasFocus, int row, int column) {   
        super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);   
        if (value instanceof Icon) {   
            setIcon((Icon)value);   
            setText(null);   
        } else {   
            setIcon(null);   
        }   
        return this;   
    }   
}  
