/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import java.awt.Color;
import java.awt.ComponentOrientation;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.Icon;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileSystemView;
import javax.swing.table.DefaultTableModel;

import comunicacao.exception.NotConnectedException;

import userManagement.User;

import core.ClienteComunication;
import core.InformationCliente;
import core.ProgramServer;
import core.Verifier;
import core.Uploader;


/**
 *
 * @author Dyego, um carai. Foi Pedro
 */
public class Principal extends javax.swing.JPanel {

	private Inicio inicio;
	private DefaultTableModel model;
	private DefaultTableModel modelGeral;
	private File[] files;
	private String path;
	private ThreadGrafico threadGraph;
	private ThreadTabela threadTabela;
	private JFrame janelaGrafico;
	public User user;
	private ProgramServer programServer;
	private Verifier verifier;
	
	/**
	 * Creates new form Principal
	 */
	public Principal(Inicio inicio) {
		initComponents();
		this.inicio = inicio;
		this.model = (DefaultTableModel) tabela.getModel();
		this.modelGeral = (DefaultTableModel) tabelaGeral.getModel();
		this.files = null;
		this.path = "";
		this.threadGraph = null;
		this.janelaGrafico = null;
		this.threadTabela = null;
		this.verifier = null;
		tabelaGeral.getColumn("").setCellRenderer(new MyCellRenderer());
	}
	
	public void criarVerifier(User user, String addressYamBox, ProgramServer programServer){
//		File yamFolder = new File("C:\\YamBox\\");
//		yamFolder.mkdir();
		
		this.verifier = new Verifier(user, addressYamBox, programServer);
		this.programServer = programServer;
		this.verifier.start();
	}
	
	public void setLabelWelcome(String label) {
		labelWelcome.setText(label);
	}

	public void setCampoPasta(String pathname) {
		campoPasta.setText(pathname);
	}
	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        labelWelcome = new javax.swing.JLabel();
        campoPasta = new javax.swing.JTextField();
        botaoFind = new javax.swing.JButton();
        labelLogoff = new javax.swing.JLabel();
        botaoRefresh = new javax.swing.JButton();
        botaoUpload = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        tabela = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        botaoUpFolder = new javax.swing.JButton();
        gambiarra = new javax.swing.JLabel();
        panelGrafico = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        tabelaGeral = new javax.swing.JTable();
        jLabel3 = new javax.swing.JLabel();
        botaoDownload = new javax.swing.JButton();
        background = new javax.swing.JLabel();

        setMaximumSize(new java.awt.Dimension(800, 600));
        setMinimumSize(new java.awt.Dimension(800, 600));
        setPreferredSize(new java.awt.Dimension(800, 600));
        setLayout(null);

        labelWelcome.setFont(new java.awt.Font("Tahoma", 0, 18));
        labelWelcome.setForeground(new java.awt.Color(255, 255, 255));
        labelWelcome.setText("Welcome, Fulano!");
        labelWelcome.setMaximumSize(new java.awt.Dimension(350, 22));
        labelWelcome.setMinimumSize(new java.awt.Dimension(350, 22));
        labelWelcome.setPreferredSize(new java.awt.Dimension(350, 22));
        add(labelWelcome);
        labelWelcome.setBounds(10, 11, 350, 22);
        add(campoPasta);
        campoPasta.setBounds(10, 533, 633, 20);

        botaoFind.setText("Find");
        botaoFind.setOpaque(false);
        botaoFind.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botaoFindActionPerformed(evt);
            }
        });
        add(botaoFind);
        botaoFind.setBounds(656, 532, 130, 23);

        labelLogoff.setForeground(new java.awt.Color(255, 255, 255));
        labelLogoff.setText("Log off");
        labelLogoff.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                labelLogoffMouseClicked(evt);
            }
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                labelLogoffMouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                labelLogoffMouseExited(evt);
            }
        });
        add(labelLogoff);
        labelLogoff.setBounds(721, 11, 35, 14);

        botaoRefresh.setText("Refresh");
        botaoRefresh.setOpaque(false);
        botaoRefresh.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botaoRefreshActionPerformed(evt);
            }
        });
        add(botaoRefresh);
        botaoRefresh.setBounds(650, 50, 140, 30);

        botaoUpload.setText("Upload");
        botaoUpload.setOpaque(false);
        botaoUpload.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botaoUploadActionPerformed(evt);
            }
        });
        add(botaoUpload);
        botaoUpload.setBounds(650, 90, 140, 30);

        tabela.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "", "Name", "Up / Down", "Status", "Speed", "ETL"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tabela.setShowHorizontalLines(false);
        tabela.setShowVerticalLines(false);
        tabela.getTableHeader().setReorderingAllowed(false);
        tabela.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tabelaMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(tabela);
        tabela.getColumnModel().getColumn(0).setMinWidth(30);
        tabela.getColumnModel().getColumn(0).setPreferredWidth(30);
        tabela.getColumnModel().getColumn(0).setMaxWidth(30);
        tabela.getColumnModel().getColumn(1).setMinWidth(30);
        tabela.getColumnModel().getColumn(1).setPreferredWidth(100);
        tabela.getColumnModel().getColumn(2).setMinWidth(30);
        tabela.getColumnModel().getColumn(2).setPreferredWidth(70);

        add(jScrollPane1);
        jScrollPane1.setBounds(10, 370, 630, 150);
        add(jLabel1);
        jLabel1.setBounds(615, 11, 0, 0);

        botaoUpFolder.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/folder_up.png"))); // NOI18N
        botaoUpFolder.setMargin(new java.awt.Insets(2, 2, 2, 2));
        botaoUpFolder.setOpaque(false);
        botaoUpFolder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botaoUpFolderActionPerformed(evt);
            }
        });
        add(botaoUpFolder);
        botaoUpFolder.setBounds(619, 11, 24, 22);

        gambiarra.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                gambiarraMouseClicked(evt);
            }
        });
        add(gambiarra);
        gambiarra.setBounds(640, 200, 160, 130);

        panelGrafico.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                panelGraficoMouseClicked(evt);
            }
        });
        add(panelGrafico);
        panelGrafico.setBounds(650, 210, 140, 110);

        tabelaGeral.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "", "Name", "Type", "Last Modified"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tabelaGeral.setShowHorizontalLines(false);
        tabelaGeral.setShowVerticalLines(false);
        tabelaGeral.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tabelaGeralMouseClicked(evt);
            }
        });
        jScrollPane2.setViewportView(tabelaGeral);
        tabelaGeral.getColumnModel().getColumn(0).setMinWidth(30);
        tabelaGeral.getColumnModel().getColumn(0).setPreferredWidth(30);
        tabelaGeral.getColumnModel().getColumn(0).setMaxWidth(30);
        tabelaGeral.getColumnModel().getColumn(2).setMinWidth(30);

        add(jScrollPane2);
        jScrollPane2.setBounds(10, 40, 630, 310);

        jLabel3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/LogoWithArchives.png"))); // NOI18N
        add(jLabel3);
        jLabel3.setBounds(650, 380, 150, 130);

        botaoDownload.setText("Download");
        botaoDownload.setOpaque(false);
        botaoDownload.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botaoDownloadMouseClicked(evt);
            }
        });
        add(botaoDownload);
        botaoDownload.setBounds(650, 130, 140, 30);

        background.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/background.jpg"))); // NOI18N
        background.setText("jLabel2");
        background.setMaximumSize(new java.awt.Dimension(800, 600));
        background.setMinimumSize(new java.awt.Dimension(800, 600));
        background.setPreferredSize(new java.awt.Dimension(800, 600));
        add(background);
        background.setBounds(0, 0, 800, 600);
    }// </editor-fold>//GEN-END:initComponents

	
	public void downloadar() {
		
	}
	
	public void setPath(String path) {
		this.path = path;
	}
	
	private void limparGeral() {

		this.campoPasta.setText("");

		//Limpando tabelas

		for(int i = this.model.getRowCount() - 1; i > -1; i--) {
			this.model.removeRow(i);
		}
		
		for(int i = this.modelGeral.getRowCount() - 1; i > -1; i--) {
			this.modelGeral.removeRow(i);
		}
		
		//Limpando Grafico
		this.threadGraph.killThread();
		this.panelGrafico.removeAll();
		this.janelaGrafico.setVisible(false);
		
		//Limpando thread Tabela
		this.threadTabela.killThread();
		
		
	}
	
	public void preencherTabelaGeral(String path) {
		
		//tabelaGeral.getColumn("").setCellRenderer(new MyCellRenderer());
		modelGeral.setRowCount(0);   
		
		SimpleDateFormat sdf = new SimpleDateFormat("MM/dd/yyyy HH:mm");
		File dir = new File(path);
		String type = "";
		String modified = "";
		Icon icon = null; 
		
		this.files = dir.listFiles();
		
		for (int i = 0; i < this.files.length; i++) {   

			File file = this.files[i];

			FileSystemView view = FileSystemView.getFileSystemView();      
			icon = view.getSystemIcon(file);  

			if(file.isDirectory()) {
				type = "Folder";
			} else {
				type = "File";
			}

			modified = sdf.format(file.lastModified());

			Object[] rowData = new Object[] {icon, file.getName(), type, modified};   
			modelGeral.addRow(rowData);   

		} 
	}
	
	public void iniciarThreadTabela() {
		tabela.getColumn("Status").setCellRenderer(new ProgressRenderer());
		tabela.getColumn("").setCellRenderer(new MyCellRenderer());
		
		this.threadTabela = new ThreadTabela(this);
		Thread t = new Thread(this.threadTabela);
		t.start();
	}
	
	public void preencherTabelaSync() {

		model.setRowCount(0);   
		Icon icon = null; 
		ArrayList<InformationCliente> informacoes = ((ClienteComunication) this.programServer).getInformationClientes();
		
		if(informacoes.size() != 0) {
			this.botaoDownload.setEnabled(false);
		} else {
			this.botaoDownload.setEnabled(true);
		}
		
		// teste
		Object[] teste = new Object[] {null, "peao", "Up/Down", 50, "20 MB/s", 30};   
		model.addRow(teste);
		
		for (int i = 0; i < informacoes.size(); i++) {
			if(informacoes.get(i) != null){
				File file = informacoes.get(i).getFile();
				
				FileSystemView view = FileSystemView.getFileSystemView();      
				icon = view.getSystemIcon(file);  
				
				int perCents = (int) (informacoes.get(i).getPerCents() * 100);
				System.out.println("***************************************porcentagem foi: " + perCents);
				int speed = (int) informacoes.get(i).getTaxe();
				
				String upDown = "";
				char type = informacoes.get(i).getType();
				
				if(type == 'D') {
					upDown = "Download";
				} else {
					upDown = "Upload";
				}
				
											  //icone, nome arquivo, up/down, progressBar, velo,     ETL
				Object[] rowData = new Object[] {icon, file.getName(), upDown, perCents, "20 MB/s", "time left"};   
				model.addRow(rowData); 
				
				//Iniciar thread referente a linha da tabela
				//ThreadBar aux2 = new ThreadBar(0, 100, 0, 0, i, this.model, this.inicio.getTrayIcon());// TODO estes valores serao retornados por alguemjoao
				//Thread aux = new Thread(aux2);
				//aux.start();
			}
			
		}	
	}

	
	public void inicializarGrafico() {
		
		//Grafico pequeno
		Grafico gPequeno = new Grafico();
		this.panelGrafico.add(gPequeno.chartPanel);
		
		//Grafico grande
                Grafico gGrande = new Grafico();
                gGrande.chartPanel.setPreferredSize(new java.awt.Dimension(500, 270));
                this.janelaGrafico = new JFrame();
                this.janelaGrafico.pack();
                this.janelaGrafico.setContentPane(gGrande.chartPanel);
                this.janelaGrafico.setSize(new java.awt.Dimension(500, 270));
                this.janelaGrafico.setDefaultCloseOperation(janelaGrafico.DISPOSE_ON_CLOSE);

                //Thread do grande e pequeno
		this.threadGraph = new ThreadGrafico(gPequeno, gGrande);
		Thread t = new Thread(threadGraph);
		t.start();
	}
        
	private void labelLogoffMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_labelLogoffMouseEntered
		labelLogoff.setForeground(Color.BLUE);
	}//GEN-LAST:event_labelLogoffMouseEntered

	private void labelLogoffMouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_labelLogoffMouseExited
		labelLogoff.setForeground(Color.WHITE);
	}//GEN-LAST:event_labelLogoffMouseExited

	private void botaoFindActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botaoFindActionPerformed
		JFileChooser escolherPasta = new JFileChooser();
		escolherPasta.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);

		int returnVal = escolherPasta.showOpenDialog(this.inicio);

		if(returnVal == escolherPasta.APPROVE_OPTION) {
			String path = escolherPasta.getSelectedFile().getPath();

			this.inicio.getPrincipal().setCampoPasta(path);
		}
	}//GEN-LAST:event_botaoFindActionPerformed

	private void labelLogoffMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_labelLogoffMouseClicked
		
		int escolha = JOptionPane.showConfirmDialog(null, "Are you sure?", "Logoff", JOptionPane.YES_NO_OPTION);
		
		if(escolha == JOptionPane.YES_OPTION) {

			this.limparGeral();
			this.inicio.setUsuarioLogado(null);
			this.verifier.desconecte();
			
			//this.programServer.desconect();
			
			this.inicio.setContentPane(this.inicio.getLogin());
			this.inicio.getLogin().revalidate();
		} 
		

	}//GEN-LAST:event_labelLogoffMouseClicked

	private void botaoRefreshActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botaoRefreshActionPerformed
		
		if(this.path != "") {
			this.preencherTabelaGeral(this.path);
		} 
	}//GEN-LAST:event_botaoRefreshActionPerformed

	private void botaoUploadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botaoUploadActionPerformed

		String datapath = campoPasta.getText();
		File file = new File(datapath);
		
		if(file.exists()){
			Uploader uploader = new Uploader();
			try {
				uploader.upload(file, this.user.getEmail());
				this.campoPasta.setText("");
			} catch (IOException e) {
				e.printStackTrace();
			}
		} else {
			this.campoPasta.setText("");
		}
		
		
//		if(file.exists()) {
//			this.inicio.getTransfer().setVisible(true);
//			this.inicio.getTransfer().pintarBarra();
//		}
		
		
	}//GEN-LAST:event_botaoUploadActionPerformed

private void tabelaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tabelaMouseClicked

}//GEN-LAST:event_tabelaMouseClicked

private void botaoUpFolderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botaoUpFolderActionPerformed

	boolean achou = false;

	for (int i = this.path.length()-1; i > -1 && !achou; i--) {

		if(this.path.charAt(i) == '\\' || this.path.charAt(i) == '/') {
			
			if(this.path.substring(0, i).contains("YamBox")){
				this.path = this.path.substring(0, i);
				achou = true;
				this.preencherTabelaGeral(this.path);
			}
		}
	}
	
}//GEN-LAST:event_botaoUpFolderActionPerformed

private void panelGraficoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_panelGraficoMouseClicked

}//GEN-LAST:event_panelGraficoMouseClicked

private void gambiarraMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_gambiarraMouseClicked
    if(evt.getClickCount() == 2) {
    	this.janelaGrafico.setVisible(true);
    }
}//GEN-LAST:event_gambiarraMouseClicked

private void tabelaGeralMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tabelaGeralMouseClicked

	if(evt.getClickCount() == 2) {
		File aux = files[tabelaGeral.getSelectedRow()];
		
		if(aux.isDirectory()) {
			this.path = aux.getPath();
			preencherTabelaGeral(this.path);
		} else {
			this.downloadar();
		}

	}
}//GEN-LAST:event_tabelaGeralMouseClicked

private void botaoDownloadMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_botaoDownloadMouseClicked
    // TODO add your handling code here:
    ArrayList<InformationCliente> informacoes = ((ClienteComunication) this.programServer).getInformationClientes();
    
    if(informacoes.size() == 0){
        // se nao tiver ninguem, manda fazer o download
        // muda o texto do botao para "wait x segundos..."
        // x vai ser o maior ETL
        // o botao fica 'nao disponivel'
    }
}//GEN-LAST:event_botaoDownloadMouseClicked



    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel background;
    private javax.swing.JButton botaoDownload;
    private javax.swing.JButton botaoFind;
    private javax.swing.JButton botaoRefresh;
    private javax.swing.JButton botaoUpFolder;
    private javax.swing.JButton botaoUpload;
    private javax.swing.JTextField campoPasta;
    private javax.swing.JLabel gambiarra;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel labelLogoff;
    private javax.swing.JLabel labelWelcome;
    private javax.swing.JPanel panelGrafico;
    private javax.swing.JTable tabela;
    private javax.swing.JTable tabelaGeral;
    // End of variables declaration//GEN-END:variables
}
